##
 # rulrd.mak
 # Copyright (C) 2015-2016 Peter Belkner <pbelkner@snafu.de>
 #
 # This file is part of libya.
 #
 # libya is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
 #
 # libya is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with libya.  If not, see <http://www.gnu.org/licenses/>.
 ##
include $(SRCDIR)/../config.mak

###############################################################################
DOS2UX=$(shell echo '$(1)'|sed -e 's,^\(.\):/,/\1/,g')
export PATH+=:$(call DOS2UX,$(MSVS))/Common7/IDE

###############################################################################
CL='$(MSVC)/bin/cl' -nologo
LIB='$(MSVC)/bin/lib' -nologo -ignore:4221

# CRT Library Features
# https://msdn.microsoft.com/en-us/library/abx4dbyh.aspx
#CFLAGS+=-O2
#CFLAGS+=-MT
#CFLAGS+=-MD
#CFLAGS+=-WX

#CPPFLAGS+=-D_MT
#CPPFLAGS+=-D_DLL
CPPFLAGS+='-I$(SRCDIR)'
CPPFLAGS+='-I$(MSVC)/include'
CPPFLAGS+='-I$(MSSDK)/include'
CPPFLAGS+='-I$(WASDK)'


###############################################################################
$(INCLUDEDIR)/%: $(SRCDIR)/%
	mkdir -p $(@D)
	cp $< $@
$(LIBDIR)/%: %
	mkdir -p $(@D)
	cp $< $@

###############################################################################
# From a command's output remove
# * empty lines,
# * lines consisting of the source name,
# * lines starting with "Creating", and
# * lines starting with "Replacing".
RE=\(^[ \t]*$$\)\|\(^$(<F)$$\)\|\(^[ \t]*Creating\)\|\(^[ \t]*Replacing\)

define exec
	$(1) > x.tmp; y=$$?; sed -n '/$(RE)/!p' x.tmp; rm x.tmp; exit $$y
endef

define CL.obj
	@echo 'CL	$(@F)'
	@$(call exec,$(CL) $(CFLAGS) $(CPPFLAGS) -c -Fo$@ $<)
endef

define CL.exe
	@echo 'LINK	$(@F)'
	@$(call exec, \
	  $(CL) $(CFLAGS) $(CPPFLAGS) -Fe$@ $^ -link $(LDFLAGS) $(LDLIBS))
endef

define CL.dll
	@echo 'LINK	$(@F)'
	@$(call exec, \
	  $(CL) -LD $(CFLAGS) $(CPPFLAGS) -Fe$@ $^ -link $(LDFLAGS) $(LDLIBS))
endef

define LIB.lib
	@echo 'LIB	$(@F)($(<F))'
	@$(call exec, \
	  if test -e $@; then $(LIB) -out:$@ $@ $<; else $(LIB) -out:$@ $<; fi)
endef

define RC.res
	@echo 'RC	$(@F)'
	@$(call exec,$(RC) $(RCFLAGS) -fo$@ $<)
endef

%.dll:
	$(CL.dll)
%.exe:
	$(CL.exe)
(%.obj): %.obj
	$(LIB.lib)
%.obj: $(SRCDIR)/%.c
	$(CL.obj)
%.obj: $(SRCDIR)/%.cpp
	$(CL.obj)
%-sse2.obj: $(SRCDIR)/%.c
	$(CL.obj)
%-debug.obj: $(SRCDIR)/%.c
	$(CL.obj)
%-debug-sse2.obj: $(SRCDIR)/%.c
	$(CL.obj)
%.res: %.rc
	$(RC.res)
